#property indicator_separate_window //  .  
#property indicator_buffers 4
#property indicator_color1 Green // 
#property indicator_style1 0
#property indicator_color2 Red // 
#property indicator_style2 2
#property indicator_maximum 100
#property indicator_minimum 0
#property indicator_level1 80
#property indicator_level2 20

//  
extern int Eperiod=22; //   EMA
   double ke; // . EMA   EMA
extern int Kperiod=5; // %K  ; =0 -  
extern int Dperiod=3; // %D  
   double kd; // . EMA  
extern int Slowing=3; // 
   double ks; // . EMA  
extern int Dmethod=0; //  MA : 0-SMA, 1-EMA
extern int PriceFild=0; //  : 0-High/Low; 1-Close/Close
extern double Sens=0; //   .
   double sens; //    

 int History=0; //  : 0 -  

// .
double   
   Main[], // 
   Signal[], // 
   Front[],
   Back[];

//  
bool first=1; //   

int init()
  {
   first=1;
   if(Sens>0) { 
      sens=Sens*Point*Slowing; //    
      string _sens=DoubleToStr(Sens,1)+" ";
     }
   
   if(Dmethod==1) kd=2.0/(1+Dperiod); // . EMA  
   
   ke=2.0/(1+Eperiod); // . EMA  
   ks=2.0/(1+Slowing); // . EMA  

   //     
   string _str="Main("+Kperiod+","+Slowing+")";
   SetIndexBuffer(0,Main);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,_str);
   //  
   _str="Signal("+Dperiod+")";
   SetIndexBuffer(1,Signal);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,_str);

   //  FB
   _str="("+Eperiod+")";
   SetIndexBuffer(2,Front);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexLabel(2,"Front"+_str);

   SetIndexBuffer(3,Back);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexLabel(3,"Back"+_str);

   //  
   if(Sens>0) string ShName=_sens;
   ShName=ShName+"Stoch ";
   if(PriceFild==0) ShName=ShName+"H/L";
   else ShName=ShName+"C/C";
   ShName=ShName+" ("+Kperiod+"/"+Eperiod+","+Dperiod+","+Slowing+")";
   IndicatorShortName(ShName);   
   
   return(0);
  }

void reinit() // -  
  {
   ArrayInitialize(Main,0.0);
   ArrayInitialize(Signal,0.0);
   ArrayInitialize(Front,0.0);
   ArrayInitialize(Back,0.0);
  }

int lim() { //  
   int ic=Bars-1-IndicatorCounted();
   if(ic<2) int limit=ic;
   else {
      if(History!=0 && History<Bars) limit=History-1;
      else limit=Bars-1;
      if(!first) reinit();
     }
   return(limit);
  }
  
void start()
  {
   int limit=lim();
//   int limit=Bars-1-IndicatorCounted();
   for(int i=limit; i>=0; i--) {
//      bool reset=limit>1 && i==limit;
//      bool NewBar=i>0;

      if(i+Kperiod+Slowing>Bars) continue; //   - 
      //     /

      double max=0,min=0,maxK=0,minK=0,maxE=0,minE=0,c=0;

      if(PriceFild==1) { //  Close
         if(Close[i]<Back[i+1]) Back[i]=ke*Close[i]+(1-ke)*Back[i+1];
         else Back[i]=Close[i];
         if(Close[i]>Front[i+1]) Front[i]=ke*Close[i]+(1-ke)*Front[i+1];
         else Front[i]=Close[i];
        }
      else { //  High/Low
         if(High[i]<Back[i+1]) Back[i]=ke*High[i]+(1-ke)*Back[i+1];
         else Back[i]=High[i];
         if(Low[i]>Front[i+1]) Front[i]=ke*Low[i]+(1-ke)*Front[i+1];
         else Front[i]=Low[i];
        }

      for(int j=i; j<i+Slowing; j++) {
         if(Kperiod>0) {
            if(PriceFild==1) { //  Close
               maxK+=Close[ArrayMaximum(Close,Kperiod,j)];
               minK+=Close[ArrayMinimum(Close,Kperiod,j)];
              }
            else { //  High/Low
               maxK+=High[ArrayMaximum(High,Kperiod,j)];
               minK+=Low[ArrayMinimum(Low,Kperiod,j)];
              }
           }
         maxE+=Back[j];
         minE+=Front[j];
         c+=Close[j];
        }
      // 
      max=MathMax(maxK,maxE);
      min=MathMin(minK,minE);
      double delta=max-min; // 
      double diff=sens-delta; //    .  
      if(diff>0) { //   >0 (  ), 
         delta=sens; //  = ,
         min-=diff/2; //   
        }
      //  
      if(delta==0) Main[i]=0;
      else Main[i]=100*(c-min)/delta;
     }
      
   first=0;
  }


